<app-spinner [show]="isLoading"></app-spinner>
<div class="d-flex flex-column h-100">
  <div class="header-container">
    <div class="d-flex align-items-center h-100 text-white">
      <h3 class="flex-fill m-0 title-label text-white">Wait List</h3>
      <mat-icon class="ic-close text-white" (click)="onCancel()">close</mat-icon>
    </div>
  </div>

  <div class="wait-list-body-content d-flex flex-column">

    <section class="filter-section">

      <div class="d-flex">

        <mat-form-field [appearance]="apperance" class="full-width">
          <mat-label>{{patientSearch.value ? 'Patient' : ''}}</mat-label>
          <input matInput class="d-none" [value]="patientSearch.value"/>
          <app-patient-search class="search-patient" #patientSearch [isHideAdd]="true"
                              (valueChanged)="onSelectPatient($event)" a
                              placeHolder="Search Patient ( ID, Name or Mobile No.)">
          </app-patient-search>
        </mat-form-field>

        <button class="no-border-bg-btn" style="margin-top: -20px;"
                (click)="isWaitListPopupOpen = !isWaitListPopupOpen">
          <span class="k-icon k-i-filter" id="filterWaitList" style="font-size: 22px; color: #575757;"></span>
        </button>
        <button class="no-border-bg-btn" style="margin-top: -20px;" *ngIf="isDisplayClear" (click)="clearFilter()">
          <span class="k-icon k-i-filter-clear" style="font-size: 22px; color: #575757;"></span>
        </button>
        <button class="no-border-bg-btn" style="margin-top: -20px;" (click)="exportWaitList()">
          <img src="./assets/Share.png"/>
        </button>

      </div>

    </section>

    <mat-divider></mat-divider>

    <section style="overflow: auto; height: calc(100vh - 212px);" *ngIf="waitListFiltered.length > 0">

      <div class="wait-list-card overflow-auto" *ngFor="let wl of waitListFiltered">

        <div class="wlc-header d-flex align-items-center">

          <mat-icon class="m-0" style="width: 18px; height: 18px; font-size: 18px;" *ngIf="wl.highPriority">warning</mat-icon>
          <span class="flex-fill" style="padding: 0 10px;">{{wl.patientName}} <span
            *ngIf="wl.gender"> ({{wl.gender.substr(0, 1)}}) </span></span>
          <button *appAccess="APPT_BASIC; lookFor: 'E'" mat-icon-button (click)="addEditWaitList(wl)">
            <mat-icon class="m-0">edit</mat-icon>
          </button>
          <button *appAccess="APPT_BASIC; lookFor: 'D'" mat-icon-button (click)="delete(wl.id)">
            <mat-icon class="m-0">delete</mat-icon>
          </button>

        </div>

        <div class="wlc-body d-flex flex-column">

          <div class="pfd-container d-flex align-items-center justify-content-center">

            <div [class.has]="pfd.value.morning || pfd.value.afternoon || pfd.value.evening"
                 class="pfd-wrapper d-flex flex-column align-items-center justify-content-center"
                 *ngFor="let pfd of wl.preferredDaysData | keyvalue: sortDays">
              <span>{{pfd.key.substr(0, 1)}}</span>
              <div class="d-flex">
                <span style="width: 6px; height: 6px; background: #00AEEF;" *ngIf="pfd.value.morning"></span>
                <span style="width: 6px; height: 6px; background: #FF8333; margin-left: 3px;"
                      *ngIf="pfd.value.afternoon"></span>
                <span style="width: 6px; height: 6px; background: #A18BD6; margin-left: 3px;"
                      *ngIf="pfd.value.evening"></span>
              </div>
            </div>

          </div>

          <div class="wlc-wl-info-container d-flex flex-column justify-content-start">

            <div class="wl-info d-flex" *ngIf="wl.practitionerName">
              <span class="wlinf-title">Practitioner: </span>
              <span class="wlinf-value">{{wl.practitionerName}}</span>
            </div>

            <div class="wl-info d-flex" *ngIf="wl.serviceName">
              <span class="wlinf-title">Service: </span>
              <span class="wlinf-value">{{wl.serviceName}}</span>
            </div>

            <div class="wl-info d-flex" *ngIf="wl.mobileNo">
              <span class="wlinf-title">Mobile: </span>
              <span class="wlinf-value">{{wl.mobileNo}}</span>
            </div>

            <div class="wl-info d-flex" *ngIf="wl.note">
              <span class="wlinf-title">Notes: </span>
              <span class="wlinf-value">{{wl.note}}</span>
            </div>

          </div>

        </div>

        <mat-divider></mat-divider>

        <div class="wlc-footer d-flex align-items-center">

          <div class="flex-fill" style="font-size: 12px; color: #828282;">
            Expiry: {{wl.expiryDate | timeFormat: 'DD MMM YYYY'}}
          </div>

          <button class="no-border-bg-btn d-flex align-items-center" style="font-size: 14px; color: #00AEEF;"
                  *appAccess="APPT_BASIC; lookFor: 'C'"
                  (click)="bookNow(wl)">
            <mat-icon>add_circle</mat-icon>
            <span>Book Now</span>
          </button>

        </div>

      </div>

    </section>

    <section class="flex-fill position-relative" *ngIf="waitListFiltered.length === 0">

      <app-empty-practitioner
        [small]="true"
        [urlBtn]="true"
        title="You haven’t added a patient to wait list"
        message="You can add patient(s) to wait list by clicking on Add to Wait List button."
        urlTitle="Add to waitList"
        (clickUrlBtn)="addEditWaitList()">
      </app-empty-practitioner>

    </section>

    <mat-divider *ngIf="waitListFiltered.length > 0"></mat-divider>

    <section class="add-btn-container d-flex align-items-center justify-content-end"
             style="height: 72px; padding-right: 10px;">
      <button *appAccess="APPT_BASIC; lookFor: 'C'" mat-raised-button color="primary" style="width: 169px; height: 52px;" (click)="addEditWaitList()">Add to
        Wait List
      </button>
    </section>
  </div>
</div>

<dx-popover class="app-popup" target="#filterWaitList" [width]="200" [height]="'auto'"
            [shading]="false" [visible]="isWaitListPopupOpen" (onHidden)="isWaitListPopupOpen = false;">
  <div *dxTemplate="let data of 'content'">
    <button class="app-popup-list-button d-flex align-items-center text-left w-100" (click)="filter(PTTR)">
      <div class="flex-fill">
        Practitioners
      </div>
    </button>

    <button class="app-popup-list-button d-flex align-items-center text-left w-100" (click)="filter(ED)">
      <div class="flex-fill">
        Expiry Date
      </div>
    </button>

    <button class="app-popup-list-button d-flex align-items-center text-left w-100" (click)="filter(PD)">
      <div class="flex-fill">
        Preferred Days
      </div>
    </button>
  </div>
</dx-popover>

<!-- DATE FILTER TEMPLATE -->
<ng-template #dateFilter>
  <div class="ac-date-filter-container" style="padding: 20px;">

    <div class="mb-2 normal_14px_22px_font" style="color: #1c1b1b;">
      Please select the expiry date range to filter the Wait List:
    </div>

    <div class="w-100 text-right">
      <mat-hint align="end" class="required-hint">Required</mat-hint>
    </div>
    <mat-form-field appearance="outline" class="full-width">
      <mat-label class="disable-label">From Date</mat-label>

      <app-date-picker
                       icon="./assets/ic-calendar-big.png"
                       [value]="fromDateCtrlVal"
                       (valueChange)="onDateSelect($event, FROM_DATE)"></app-date-picker>

<!--      <input matInput #fromDate style="color: #999999 !important;" class="bg-transparent" [readonly]="true"-->
<!--             [value]="fromDateCtrl.value | timeFormat: 'DD/MM/YYYY'"/>-->
<!--      <app-calender-popup [anchor]="fromDate" [value]="fromDateCtrlVal"-->
<!--                          (valueChange)="onDateSelect($event, FROM_DATE)"></app-calender-popup>-->
<!--      <img matSuffix src="./assets/ic-calendar-big.png" style="margin-top: -12px;"/>-->
    </mat-form-field>

    <div class="w-100 text-right">
      <mat-hint align="end" class="required-hint">Required</mat-hint>
    </div>
    <mat-form-field appearance="outline" class="full-width">
      <mat-label class="disable-label">To Date</mat-label>

      <app-date-picker
              icon="./assets/ic-calendar-big.png"
              [value]="toDateCtrlVal"
              [min]="fromDateCtrlVal"
              (valueChange)="onDateSelect($event, TO_DATE)"></app-date-picker>

<!--      <input matInput #toDate style="color: #999999 !important;" class="bg-transparent" [readonly]="true"-->
<!--             [value]="toDateCtrl.value | timeFormat: 'DD/MM/YYYY'"/>-->
<!--      <app-calender-popup [anchor]="toDate" [value]="toDateCtrlVal" [min]="fromDateCtrl.value"-->
<!--                          (valueChange)="onDateSelect($event, TO_DATE)"></app-calender-popup>-->
<!--      <img matSuffix src="./assets/ic-calendar-big.png" style="margin-top: -12px;"/>-->
    </mat-form-field>

  </div>
</ng-template>

<!-- PREFERRED DAYS FILTER TEMPLATE -->
<ng-template #pDaysTemplate>
  <div class="ac-date-filter-container" style="padding: 20px;">

    <div class="mb-2 normal_14px_22px_font" style="color: #1c1b1b;">
      Please select the preferred days to filter the Wait List:
    </div>

    <div>
      <div class="btn-group btn-group-toggle">
        <label class="btn-outline-primary btn-circle day-btn active" ngbButtonLabel *ngFor="let day of DAYS">
          <input type="checkbox" ngbButton [(ngModel)]="selectedPDays[day]" (change)="togglePDays($event, day)">
          {{day.substr(0, 1)}}
        </label>
      </div>
    </div>

  </div>
</ng-template>

<ng-template #deleteConfirm>
  <div style="padding: 20px;">
    Patient removed from wait list cannot be restored.
  </div>
</ng-template>
